Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3679)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3681)
@@ -1751,10 +1922,182 @@
             CEILING( parentdzmax / dzmin )
        ALLOCATE( celltmpd(1:acsize) )
-!       write(9,"('acsize: ',i3,2(e12.5,2x))") acsize, dzmin, parentdzmax
       
     END SUBROUTINE pmci_init_interp_tril
-
-
-
+    
+
+
+    SUBROUTINE pmci_allocate_finegrid_workarrays
+!
+!--    Allocate child-grid work-arrays for interpolation
+       IMPLICIT NONE
+
+
+       igsr = NINT( cg%dx / dx, iwp )
+       jgsr = NINT( cg%dy / dy, iwp )
+       kgsr = NINT( cg%dzu(cg%nz+1) / dzu(nzt+1), iwp )
+       write(9,"('igsr, jgsr, kgsr: ',3(i3,2x))") igsr, jgsr, kgsr
+       flush(9)
+!       
+!--    Note that i-indexing for workarr_lr runs from 0 to igsr-1.
+!--    For u, only 0-element is used and all elements 0:igsr-1
+!--    are used for all other variables.
+       ALLOCATE( workarr_lr(nzb:nzt+1,nysg:nyng,0:igsr-1) )
+!       
+!--    Note that j-indexing for workarr_sn runs from 0 to jgsr-1.
+!--    For v, only 0-element is used and all elements 0:jgsr-1
+!--    are used for all other variables.
+       ALLOCATE( workarr_sn(nzb:nzt+1,0:jgsr-1,nxlg:nxrg) )
+!
+!--    Note that genuine k-indexing is used for workarr_t.
+!--    Only nzt-element is used for w and elements nzt+1:nzt+kgsr
+!--    are used for all other variables. 
+       ALLOCATE( workarr_t(nzt:nzt+kgsr,nysg:nyng,nxlg:nxrg) )
+
+    END SUBROUTINE pmci_allocate_finegrid_workarrays
+
+
+
+    SUBROUTINE pmci_allocate_coarsegrid_workarrays
+!
+!--    Allocate parent-grid work-arrays for interpolation
+       IMPLICIT NONE
+
+!
+!--    Determine and store the PE-subdomain dependent index bounds
+       IF  ( bc_dirichlet_l )  THEN
+          iclw = icl + 1
+       ELSE
+          iclw = icl - 1
+       ENDIF
+
+       IF  ( bc_dirichlet_r )  THEN
+          icrw = icr - 1
+       ELSE
+          icrw = icr + 1
+       ENDIF
+
+       IF  ( bc_dirichlet_s )  THEN
+          jcsw = jcs + 1
+       ELSE
+          jcsw = jcs - 1
+       ENDIF
+
+       IF  ( bc_dirichlet_n )  THEN
+          jcnw = jcn - 1
+       ELSE
+          jcnw = jcn + 1
+       ENDIF
+    
+       coarse_bound_w(1) = iclw
+       coarse_bound_w(2) = icrw
+       coarse_bound_w(3) = jcsw
+       coarse_bound_w(4) = jcnw
+!
+!--    Left and right boundaries.
+       ALLOCATE( workarrc_lr(0:cg%nz+1,jcsw:jcnw,0:2) )
+!
+!--    South and north boundaries.
+       ALLOCATE( workarrc_sn(0:cg%nz+1,0:2,iclw:icrw) )
+!
+!--    Top boundary.
+       ALLOCATE( workarrc_t(0:2,jcsw:jcnw,iclw:icrw) )
+
+    END SUBROUTINE pmci_allocate_coarsegrid_workarrays
+
+
+
+    SUBROUTINE pmci_create_coarsegrid_workarray_exchange_datatypes
+!
+!--    Define specific MPI types for workarrc-exhchange.
+       IMPLICIT NONE
+
+#if defined( __parallel )       
+!
+!--    For the left and right boundaries
+       CALL MPI_TYPE_VECTOR( 3, cg%nz+2, (jcnw-jcsw+1)*(cg%nz+2), MPI_REAL,     &
+            workarrc_lr_exchange_type, ierr )
+       CALL MPI_TYPE_COMMIT( workarrc_lr_exchange_type, ierr )
+!
+!--    For the south and north boundaries
+       CALL MPI_TYPE_VECTOR( 1, 3*(cg%nz+2), 3*(cg%nz+2), MPI_REAL,             &
+            workarrc_sn_exchange_type, ierr )
+       CALL MPI_TYPE_COMMIT( workarrc_sn_exchange_type, ierr )
+!
+!--    For the top-boundary x-slices
+       CALL MPI_TYPE_VECTOR( icrw-iclw+1, 3, 3*(jcnw-jcsw+1), MPI_REAL,         &
+            workarrc_t_exchange_type_x, ierr )
+       CALL MPI_TYPE_COMMIT( workarrc_t_exchange_type_x, ierr )
+!
+!--    For the top-boundary y-slices
+       CALL MPI_TYPE_VECTOR( 1, 3*(jcnw-jcsw+1), 3*(jcnw-jcsw+1), MPI_REAL,         &
+            workarrc_t_exchange_type_y, ierr )
+       CALL MPI_TYPE_COMMIT( workarrc_t_exchange_type_y, ierr )
+#endif
+       
+    END SUBROUTINE pmci_create_coarsegrid_workarray_exchange_datatypes
+
+
+
+    SUBROUTINE pmci_allocate_fine_to_coarse_mapping_arrays
+!
+!--    Define index limits and allocate the fine-to-coarse grid index mapping 
+!--    arrays and interpolation coefficient arrays.      
+       IMPLICIT NONE
+
+       
+       IF  ( bc_dirichlet_l )  THEN
+!AH          nxlfc = MIN( nxl-igsr, nxlg )          
+          nxlfc = nxl - igsr
+       ELSE
+!AH          nxlfc = nxlg
+          nxlfc = nxl - 1
+       ENDIF
+       IF  ( bc_dirichlet_r )  THEN
+!AH          nxrfc = MAX( nxr+igsr, nxrg )
+          nxrfc = nxr + igsr
+       ELSE
+!AH          nxrfc = nxrg
+          nxrfc = nxr + 1          
+       ENDIF
+
+       IF  ( bc_dirichlet_s )  THEN
+!AH          nysfc = MIN( nys-jgsr, nysg )
+          nysfc = nys - jgsr
+       ELSE
+!AH          nysfc = nysg
+          nysfc = nys - 1
+       ENDIF
+       IF  ( bc_dirichlet_n )  THEN
+!AH          nynfc = MAX( nyn+jgsr, nyng )
+          nynfc = nyn + jgsr
+       ELSE
+!AH          nynfc = nyng          
+          nynfc = nyn + 1          
+       ENDIF
+
+       ALLOCATE( icu(nxlfc:nxrfc) )       
+       ALLOCATE( ico(nxlfc:nxrfc) )
+       ALLOCATE( jcv(nysfc:nynfc) )
+       ALLOCATE( jco(nysfc:nynfc) )
+       ALLOCATE( kcw(nzb:nzt+kgsr) )
+       ALLOCATE( kco(nzb:nzt+kgsr) )
+
+       ALLOCATE( r1xu(nxlfc:nxrfc) )
+       ALLOCATE( r2xu(nxlfc:nxrfc) )
+       ALLOCATE( r1xo(nxlfc:nxrfc) )
+       ALLOCATE( r2xo(nxlfc:nxrfc) )
+       ALLOCATE( r1yv(nysfc:nynfc) )
+       ALLOCATE( r2yv(nysfc:nynfc) )
+       ALLOCATE( r1yo(nysfc:nynfc) )
+       ALLOCATE( r2yo(nysfc:nynfc) )
+       ALLOCATE( r1zw(nzb:nzt+kgsr) )
+       ALLOCATE( r2zw(nzb:nzt+kgsr) )
+       ALLOCATE( r1zo(nzb:nzt+kgsr) )
+       ALLOCATE( r2zo(nzb:nzt+kgsr) )
+
+    END SUBROUTINE pmci_allocate_fine_to_coarse_mapping_arrays
+
+     
+       
     SUBROUTINE pmci_init_loglaw_correction
 !
@@ -3092,11 +3435,14 @@
        INTEGER(iwp) ::  istart   !<
        INTEGER(iwp) ::  ir       !<
+       INTEGER(iwp) ::  iw       !< Fine-grid index limited to -1 <= iw <= nx+1
        INTEGER(iwp) ::  j        !< Fine-grid index
        INTEGER(iwp) ::  jj       !< Coarse-grid index
        INTEGER(iwp) ::  jstart   !<
        INTEGER(iwp) ::  jr       !<
+       INTEGER(iwp) ::  jw       !< Fine-grid index limited to -1 <= jw <= ny+1
        INTEGER(iwp) ::  k        !< Fine-grid index
        INTEGER(iwp) ::  kk       !< Coarse-grid index
        INTEGER(iwp) ::  kstart   !<
+       INTEGER(iwp) ::  kw       !< Fine-grid index limited to kw <= nzt+1
        REAL(wp)     ::  xi       !<
        REAL(wp)     ::  eta      !<
@@ -3122,6 +3468,6 @@
        ENDIF
 !
-!--    First determine kcto and kctw that are the coarse-grid upper bounds for
-!--    index k
+!--    First determine kcto and kctw which refer to the uppermost 
+!--    coarse-grid levels below the child top-boundary level.
        kk = 0
        DO  WHILE ( cg%zu(kk) <= zu(nzt) )
@@ -3135,22 +3481,59 @@
        ENDDO
        kctw = kk - 1
-
-       ALLOCATE( iflu(icl:icr) )
-       ALLOCATE( iflo(icl:icr) )
-       ALLOCATE( ifuu(icl:icr) )
-       ALLOCATE( ifuo(icl:icr) )
-       ALLOCATE( jflv(jcs:jcn) )
-       ALLOCATE( jflo(jcs:jcn) )
-       ALLOCATE( jfuv(jcs:jcn) )
-       ALLOCATE( jfuo(jcs:jcn) )
+!AH
+       write(9,"('kcto, kctw = ', 2(i3,2x))") kcto, kctw
+
+!AH
+!       ALLOCATE( iflu(icl:icr) )
+!       ALLOCATE( iflo(icl:icr) )
+!       ALLOCATE( ifuu(icl:icr) )
+!       ALLOCATE( ifuo(icl:icr) )
+!       ALLOCATE( jflv(jcs:jcn) )
+!       ALLOCATE( jflo(jcs:jcn) )
+!       ALLOCATE( jfuv(jcs:jcn) )
+!       ALLOCATE( jfuo(jcs:jcn) )
+!       
+!       ALLOCATE( iflu(icl-1:icr+1) )
+!       ALLOCATE( iflo(icl-1:icr+1) )
+!       ALLOCATE( ifuu(icl-1:icr+1) )
+!       ALLOCATE( ifuo(icl-1:icr+1) )
+!       ALLOCATE( jflv(jcs-1:jcn+1) )
+!       ALLOCATE( jflo(jcs-1:jcn+1) )
+!       ALLOCATE( jfuv(jcs-1:jcn+1) )
+!       ALLOCATE( jfuo(jcs-1:jcn+1) )
+!
+       icla = coarse_bound_aux(1)
+       icra = coarse_bound_aux(2)
+       jcsa = coarse_bound_aux(3)
+       jcna = coarse_bound_aux(4)
+       ALLOCATE( iflu(icla:icra) )
+       ALLOCATE( iflo(icla:icra) )
+       ALLOCATE( ifuu(icla:icra) )
+       ALLOCATE( ifuo(icla:icra) )
+       ALLOCATE( jflv(jcsa:jcna) )
+       ALLOCATE( jflo(jcsa:jcna) )
+       ALLOCATE( jfuv(jcsa:jcna) )
+       ALLOCATE( jfuo(jcsa:jcna) )       
+!AH
        ALLOCATE( kflw(0:cg%nz+1) )
        ALLOCATE( kflo(0:cg%nz+1) )
        ALLOCATE( kfuw(0:cg%nz+1) )
        ALLOCATE( kfuo(0:cg%nz+1) )
-
-       ALLOCATE( ijkfc_u(0:cg%nz+1,jcs:jcn,icl:icr) )
-       ALLOCATE( ijkfc_v(0:cg%nz+1,jcs:jcn,icl:icr) )
-       ALLOCATE( ijkfc_w(0:cg%nz+1,jcs:jcn,icl:icr) )
-       ALLOCATE( ijkfc_s(0:cg%nz+1,jcs:jcn,icl:icr) )
+!AH
+!       ALLOCATE( ijkfc_u(0:cg%nz+1,jcs:jcn,icl:icr) )
+!       ALLOCATE( ijkfc_v(0:cg%nz+1,jcs:jcn,icl:icr) )
+!       ALLOCATE( ijkfc_w(0:cg%nz+1,jcs:jcn,icl:icr) )
+!       ALLOCATE( ijkfc_s(0:cg%nz+1,jcs:jcn,icl:icr) )
+!
+!       ALLOCATE( ijkfc_u(0:cg%nz+1,jcs-1:jcn+1,icl-1:icr+1) )
+!       ALLOCATE( ijkfc_v(0:cg%nz+1,jcs-1:jcn+1,icl-1:icr+1) )
+!       ALLOCATE( ijkfc_w(0:cg%nz+1,jcs-1:jcn+1,icl-1:icr+1) )
+!       ALLOCATE( ijkfc_s(0:cg%nz+1,jcs-1:jcn+1,icl-1:icr+1) )
+!
+       ALLOCATE( ijkfc_u(0:cg%nz+1,jcsa:jcna,icla:icra) )
+       ALLOCATE( ijkfc_v(0:cg%nz+1,jcsa:jcna,icla:icra) )
+       ALLOCATE( ijkfc_w(0:cg%nz+1,jcsa:jcna,icla:icra) )
+       ALLOCATE( ijkfc_s(0:cg%nz+1,jcsa:jcna,icla:icra) )
+!AH
 
        ijkfc_u = 0
@@ -3163,5 +3546,8 @@
        tolerance = 0.000001_wp * dx
        istart = nxlg
-       DO  ii = icl, icr-1
+!AH       DO  ii = icl, icr
+!AH       DO  ii = icl-1, icr+1
+          DO  ii = icla, icra
+
 !
 !--       In case the child and parent grid lines match in x 
@@ -3196,5 +3582,6 @@
              istart = iflu(ii)
           ENDIF
-!AH
+!
+!--       Print out the index bounds for checking and debugging purposes
           write(9,"('pmci_init_anterp_tophat, ii, iflu, ifuu: ', 3(i4,2x))")    &
                ii, iflu(ii), ifuu(ii)
@@ -3202,11 +3589,12 @@
 
        ENDDO
-       iflu(icr) = nxrg
-       ifuu(icr) = nxrg
+       write(9,*)
 !
 !--    i-indices of others for each ii-index value
 !--    ii=icr is redundant for anterpolation
        istart = nxlg
-       DO  ii = icl, icr-1
+!AH       DO  ii = icl, icr
+!AH       DO  ii = icl-1, icr+1
+       DO  ii = icla, icra
           i = istart
           DO  WHILE ( ( coord_x(i) + 0.5_wp * dx < cg%coord_x(ii) )  .AND.     &
@@ -3223,12 +3611,11 @@
           ifuo(ii) = MIN( MAX( i-1, iflo(ii) ), nxrg )
           istart = iflo(ii)
+!
+!--       Print out the index bounds for checking and debugging purposes
+          write(9,"('pmci_init_anterp_tophat, ii, iflo, ifuo: ', 3(i4,2x))")    &
+               ii, iflo(ii), ifuo(ii)
+          flush(9)
        ENDDO
-!AH
-       write(9,"('pmci_init_anterp_tophat, ii, iflo, ifuo: ', 3(i4,2x))")    &
-            ii, iflo(ii), ifuo(ii)
-       flush(9)
-          
-       iflo(icr) = nxrg
-       ifuo(icr) = nxrg
+       write(9,*)
 !
 !--    j-indices of v for each jj-index value
@@ -3236,5 +3623,7 @@
        tolerance = 0.000001_wp * dy
        jstart = nysg
-       DO  jj = jcs, jcn-1
+!AH       DO  jj = jcs, jcn
+!AH       DO  jj = jcs-1, jcn+1
+       DO  jj = jcsa, jcna
 !
 !--       In case the child and parent grid lines match in y 
@@ -3269,17 +3658,18 @@
              jstart = jflv(jj)
           ENDIF
-!AH
+!
+!--       Print out the index bounds for checking and debugging purposes
           write(9,"('pmci_init_anterp_tophat, jj, jflv, jfuv: ', 3(i4,2x))")    &
                jj, jflv(jj), jfuv(jj)
           flush(9)
-
        ENDDO
-       jflv(jcn) = nyng
-       jfuv(jcn) = nyng
+       write(9,*)
 !
 !--    j-indices of others for each jj-index value
 !--    jj=jcn is redundant for anterpolation
        jstart = nysg
-       DO  jj = jcs, jcn-1
+!AH       DO  jj = jcs, jcn
+!AH       DO  jj = jcs-1, jcn+1
+       DO  jj = jcsa, jcna
           j = jstart
           DO  WHILE ( ( coord_y(j) + 0.5_wp * dy < cg%coord_y(jj) )  .AND.     &
@@ -3296,12 +3686,11 @@
           jfuo(jj) = MIN( MAX( j-1, jflo(jj) ), nyng )
           jstart = jflo(jj)
-!AH
-          write(9,"('pmci_init_anterp_tophat, ii, jflo, jfuo: ', 3(i4,2x))")    &
+!
+!--       Print out the index bounds for checking and debugging purposes
+          write(9,"('pmci_init_anterp_tophat, jj, jflo, jfuo: ', 3(i4,2x))")    &
                jj, jflo(jj), jfuo(jj)
           flush(9)
-
        ENDDO
-       jflo(jcn) = nyng
-       jfuo(jcn) = nyng
+       write(9,*)
 !
 !--    k-indices of w for each kk-index value
@@ -3347,9 +3736,9 @@
           ENDIF
 !AH
-          write(9,"('pmci_init_anterp_tophat, kk, kflw, kfuw: ', 3(i4,2x))") &
-               kk, kflw(kk), kfuw(kk)
+          write(9,"('pmci_init_anterp_tophat, kk, kflw, kfuw: ', 4(i4,2x), 2(e12.5,2x))") &
+               kk, kflw(kk), kfuw(kk), nzt,  cg%zu(kk), cg%zw(kk)
           flush(9)
-
        ENDDO
+       write(9,*)
 !
 !--    k-indices of others for each kk-index value
@@ -3360,15 +3749,10 @@
 !--    Note that anterpolation index limits are needed also for the top boundary 
 !--    ghost cell level because of the reversibility correction in the interpolation.
-!AH       DO  kk = 1, kcto+1
        DO  kk = 1, cg%nz+1
           k = kstart
-!AH          DO  WHILE ( ( zu(k) < cg%zw(kk-1) )  .AND.  ( k < nzt ) )
-!--       Note that this is an IMPORTANT correction for the reversibility correction
           DO  WHILE ( ( zu(k) < cg%zw(kk-1) )  .AND.  ( k <= nzt ) )
              k = k + 1
           ENDDO
           kflo(kk) = MIN( MAX( k, 1 ), nzt + 1 )
-!AH          DO  WHILE ( ( zu(k) <= cg%zw(kk) )  .AND.  ( k < nzt+1 ) )
-!--       Note that this is an IMPORTANT correction for the reversibility correction
           DO  WHILE ( ( zu(k) <= cg%zw(kk) )  .AND.  ( k <= nzt+1 ) )
              k = k + 1
@@ -3377,23 +3761,45 @@
           kfuo(kk) = MIN( MAX( k-1, kflo(kk) ), nzt + 1 )
           kstart = kflo(kk)
-!AH
-          write(9,"('init kflo, kfuo: ', 4(i3,2x), e12.5)") kk, kflo(kk), kfuo(kk), nzt,  cg%zw(kk)
+       ENDDO
+!
+!--    Set the k-index bounds separately for the parent-grid cells cg%nz and cg%nz+1. 
+!--    Index bounds for cg%nz are needed for the reversibility correction.
+       kflo(cg%nz)   = nzt+1    ! Needed for the reversibility correction
+       kfuo(cg%nz)   = nzt+kgsr ! Needed for the reversibility correction
+       kflo(cg%nz+1) = nzt+kgsr ! Obsolete
+       kfuo(cg%nz+1) = nzt+kgsr ! Obsolete 
+
+       DO  kk = 1, cg%nz+1
+          write(9,"('pmci_init_anterp_tophat, kk, kflo, kfuo: ', 4(i4,2x), 2(e12.5,2x))") &
+               kk, kflo(kk), kfuo(kk), nzt,  cg%zu(kk), cg%zw(kk)
           flush(9)
        ENDDO
+       write(9,*)
+!AH
+
 !
 !--    Precomputation of number of fine-grid nodes inside parent-grid cells.
 !--    Note that ii, jj, and kk are parent-grid indices. 
-!--    This information is needed in anterpolation.
-       DO  ii = icl, icr
-          DO  jj = jcs, jcn
-!AH             DO kk = 0, kcto+1
+!--    This information is needed in anterpolation and in reversibility 
+!--    correction in interpolation. For the reversibility correction, ijkfc-
+!--    information is needed also beyond the indices for wall_flags_0-masking 
+!--    must be modified here in the boundary-normal direction (iw, jw, kw). 
+!AH       DO  ii = icl, icr
+!AH          DO  jj = jcs, jcn
+!AH       DO  ii = icl-1, icr+1
+!AH          DO  jj = jcs-1, jcn+1
+       DO  ii = icla, icra
+          DO  jj = jcsa, jcna
              DO kk = 0, cg%nz+1
 !
 !--             u-component
                 DO  i = iflu(ii), ifuu(ii)
+                   iw = MAX( MIN( i, nx+1 ), -1 )
                    DO  j = jflo(jj), jfuo(jj)
+                      jw = MAX( MIN( j, ny+1 ), -1 )
                       DO  k = kflo(kk), kfuo(kk)
-                         ijkfc_u(kk,jj,ii) = ijkfc_u(kk,jj,ii) + MERGE( 1, 0,  &
-                                            BTEST( wall_flags_0(k,j,i), 1 ) )
+                         kw = MIN( k, nzt+1 )                
+                         ijkfc_u(kk,jj,ii) = ijkfc_u(kk,jj,ii)                  &
+                              + MERGE( 1, 0, BTEST( wall_flags_0(kw,jw,iw), 1 ) )
                       ENDDO
                    ENDDO
@@ -3402,8 +3808,11 @@
 !--             v-component 
                 DO  i = iflo(ii), ifuo(ii)
+                   iw = MAX( MIN( i, nx+1 ), -1 )
                    DO  j = jflv(jj), jfuv(jj)
+                      jw = MAX( MIN( j, ny+1 ), -1 )
                       DO  k = kflo(kk), kfuo(kk)
-                         ijkfc_v(kk,jj,ii) = ijkfc_v(kk,jj,ii) + MERGE( 1, 0,  &
-                                            BTEST( wall_flags_0(k,j,i), 2 ) )
+                         kw = MIN( k, nzt+1 )                                        
+                         ijkfc_v(kk,jj,ii) = ijkfc_v(kk,jj,ii)                  &
+                              + MERGE( 1, 0, BTEST( wall_flags_0(kw,jw,iw), 2 ) )
                       ENDDO
                    ENDDO
@@ -3412,29 +3821,31 @@
 !--             scalars
                 DO  i = iflo(ii), ifuo(ii)
+                   iw = MAX( MIN( i, nx+1 ), -1 )
                    DO  j = jflo(jj), jfuo(jj)
+                      jw = MAX( MIN( j, ny+1 ), -1 )
                       DO  k = kflo(kk), kfuo(kk)
-                         ijkfc_s(kk,jj,ii) = ijkfc_s(kk,jj,ii) + MERGE( 1, 0,  &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) )
+                         kw = MIN( k, nzt+1 )
+                         ijkfc_s(kk,jj,ii) = ijkfc_s(kk,jj,ii)                  &
+                              + MERGE( 1, 0, BTEST( wall_flags_0(kw,jw,iw), 0 ) )
                       ENDDO
                    ENDDO
                 ENDDO
-             ENDDO
-
-!AH             DO kk = 0, kctw+1
-             DO kk = 0, cg%nz+1
 !
 !--             w-component 
                 DO  i = iflo(ii), ifuo(ii)
+                   iw = MAX( MIN( i, nx+1 ), -1 )
                    DO  j = jflo(jj), jfuo(jj)
+                      jw = MAX( MIN( j, ny+1 ), -1 )
                       DO  k = kflw(kk), kfuw(kk)
-                         ijkfc_w(kk,jj,ii) = ijkfc_w(kk,jj,ii) + MERGE( 1, 0,  &
-                                            BTEST( wall_flags_0(k,j,i), 3 ) )
+                         kw = MIN( k, nzt+1 )
+                         ijkfc_w(kk,jj,ii) = ijkfc_w(kk,jj,ii) + MERGE( 1, 0,   &
+                              BTEST( wall_flags_0(kw,jw,iw), 3 ) )
                       ENDDO
                    ENDDO
                 ENDDO
-             ENDDO
-        
-          ENDDO
-       ENDDO
+
+             ENDDO  ! kk        
+          ENDDO  ! jj
+       ENDDO  ! ii
 !
 !--    Spatial under-relaxation coefficients
@@ -3445,197 +3856,40 @@
        fray(jcs:jcn) = 1.0_wp
 
-       IF ( nesting_mode /= 'vertical' )  THEN
-          DO  ii = icl, icr
-             IF ( ifuu(ii) < ( nx + 1 ) / 2 )  THEN   
-                xi = ( MAX( 0.0_wp, ( cg%coord_x(ii) -                         &
-                     lower_left_coord_x ) ) / anterp_relax_length_l )**4
-                frax(ii) = xi / ( 1.0_wp + xi )
-             ELSE
-                xi = ( MAX( 0.0_wp, ( lower_left_coord_x + ( nx + 1 ) * dx -   &
-                                      cg%coord_x(ii) ) ) /                     &
-                       anterp_relax_length_r )**4
-                frax(ii) = xi / ( 1.0_wp + xi )                
-             ENDIF
-          ENDDO
-
-          DO  jj = jcs, jcn
-             IF ( jfuv(jj) < ( ny + 1 ) / 2 )  THEN 
-                eta = ( MAX( 0.0_wp, ( cg%coord_y(jj) -                        &
-                     lower_left_coord_y ) ) / anterp_relax_length_s )**4
-                fray(jj) = eta / ( 1.0_wp + eta )
-             ELSE
-                eta = ( MAX( 0.0_wp, ( lower_left_coord_y + ( ny + 1 ) * dy -  &
-                                       cg%coord_y(jj)) ) /                     &
-                        anterp_relax_length_n )**4
-                fray(jj) = eta / ( 1.0_wp + eta )
-             ENDIF
-          ENDDO
-       ENDIF
+!AH       IF ( nesting_mode /= 'vertical' )  THEN
+!AH          DO  ii = icl, icr
+!AH             IF ( ifuu(ii) < ( nx + 1 ) / 2 )  THEN   
+!AH                xi = ( MAX( 0.0_wp, ( cg%coord_x(ii) -                         &
+!AH                     lower_left_coord_x ) ) / anterp_relax_length_l )**4
+!AH                frax(ii) = xi / ( 1.0_wp + xi )
+!AH             ELSE
+!AH                xi = ( MAX( 0.0_wp, ( lower_left_coord_x + ( nx + 1 ) * dx -   &
+!AH                                      cg%coord_x(ii) ) ) /                     &
+!AH                       anterp_relax_length_r )**4
+!AH                frax(ii) = xi / ( 1.0_wp + xi )                
+!AH             ENDIF
+!AH          ENDDO
+!AH
+!AH          DO  jj = jcs, jcn
+!AH             IF ( jfuv(jj) < ( ny + 1 ) / 2 )  THEN 
+!AH                eta = ( MAX( 0.0_wp, ( cg%coord_y(jj) -                        &
+!AH                     lower_left_coord_y ) ) / anterp_relax_length_s )**4
+!AH                fray(jj) = eta / ( 1.0_wp + eta )
+!AH             ELSE
+!AH                eta = ( MAX( 0.0_wp, ( lower_left_coord_y + ( ny + 1 ) * dy -  &
+!AH                                       cg%coord_y(jj)) ) /                     &
+!AH                        anterp_relax_length_n )**4
+!AH                fray(jj) = eta / ( 1.0_wp + eta )
+!AH             ENDIF
+!AH          ENDDO
+!AH       ENDIF
       
        ALLOCATE( fraz(0:kcto) )
-       DO  kk = 0, kcto
-          zeta = ( ( zu(nzt) - cg%zu(kk) ) / anterp_relax_length_t )**4
-          fraz(kk) = zeta / ( 1.0_wp + zeta )
-       ENDDO
+       fraz(0:kcto) = 1.0_wp
+!AH       DO  kk = 0, kcto
+!AH          zeta = ( ( zu(nzt) - cg%zu(kk) ) / anterp_relax_length_t )**4
+!AH          fraz(kk) = zeta / ( 1.0_wp + zeta )
+!AH       ENDDO
 
     END SUBROUTINE pmci_init_anterp_tophat
-
-
-
-    SUBROUTINE pmci_init_tkefactor
-
-!
-!--    Computes the scaling factor for the SGS TKE from coarse grid to be used
-!--    as BC for the fine grid. Based on the Kolmogorov energy spectrum
-!--    for the inertial subrange and assumption of sharp cut-off of the resolved
-!--    energy spectrum. Near the surface, the reduction of TKE is made
-!--    smaller than further away from the surface.
-!--    Please note, in case parent and child model operate in RANS mode, 
-!--    TKE is not grid depenedent and weighting factor is one. 
-
-       IMPLICIT NONE
-
-       INTEGER(iwp)        ::  k                     !< index variable along z
-       INTEGER(iwp)        ::  k_wall                !< topography-top index along z
-       INTEGER(iwp)        ::  kc                    !<
-
-       REAL(wp), PARAMETER ::  cfw = 0.2_wp          !<
-       REAL(wp), PARAMETER ::  c_tkef = 0.6_wp       !<
-       REAL(wp)            ::  fw                    !<
-       REAL(wp), PARAMETER ::  fw0 = 0.9_wp          !<
-       REAL(wp)            ::  glsf                  !<
-       REAL(wp)            ::  glsc                  !<
-       REAL(wp)            ::  height                !<
-       REAL(wp), PARAMETER ::  p13 = 1.0_wp/3.0_wp   !<
-       REAL(wp), PARAMETER ::  p23 = 2.0_wp/3.0_wp   !<        
-
-!
-       IF ( .NOT. rans_mode  .AND.  .NOT. rans_mode_parent )  THEN 
-          IF ( bc_dirichlet_l )  THEN
-             ALLOCATE( tkefactor_l(nzb:nzt+1,nysg:nyng) )
-             tkefactor_l = 0.0_wp
-             i = nxl - 1
-             DO  j = nysg, nyng
-                k_wall = get_topography_top_index_ji( j, i, 's' )
-
-                DO  k = k_wall + 1, nzt
-                   kc     = kco(k) + 1
-                   glsf   = ( dx * dy * dzu(k) )**p13
-                   glsc   = ( cg%dx * cg%dy *cg%dzu(kc) )**p13
-                   height = zu(k) - zu(k_wall)
-                   fw     = EXP( -cfw * height / glsf )
-                   tkefactor_l(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *      &
-                                                 ( glsf / glsc )**p23 )
-                ENDDO
-                tkefactor_l(k_wall,j) = c_tkef * fw0
-             ENDDO
-          ENDIF
-
-          IF ( bc_dirichlet_r )  THEN
-             ALLOCATE( tkefactor_r(nzb:nzt+1,nysg:nyng) )
-             tkefactor_r = 0.0_wp
-             i = nxr + 1
-             DO  j = nysg, nyng
-                k_wall = get_topography_top_index_ji( j, i, 's' )
-
-                DO  k = k_wall + 1, nzt
-                   kc     = kco(k) + 1
-                   glsf   = ( dx * dy * dzu(k) )**p13
-                   glsc   = ( cg%dx * cg%dy * cg%dzu(kc) )**p13
-                   height = zu(k) - zu(k_wall)
-                   fw     = EXP( -cfw * height / glsf )
-                   tkefactor_r(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *      &
-                                                 ( glsf / glsc )**p23 )
-                ENDDO
-                tkefactor_r(k_wall,j) = c_tkef * fw0
-             ENDDO
-          ENDIF
-
-          IF ( bc_dirichlet_s )  THEN
-             ALLOCATE( tkefactor_s(nzb:nzt+1,nxlg:nxrg) )
-             tkefactor_s = 0.0_wp
-             j = nys - 1
-             DO  i = nxlg, nxrg
-                k_wall = get_topography_top_index_ji( j, i, 's' )
-                
-                DO  k = k_wall + 1, nzt
-    
-                   kc     = kco(k) + 1
-                   glsf   = ( dx * dy * dzu(k) )**p13
-                   glsc   = ( cg%dx * cg%dy * cg%dzu(kc) ) ** p13
-                   height = zu(k) - zu(k_wall)
-                   fw     = EXP( -cfw*height / glsf )
-                   tkefactor_s(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *      &
-                        ( glsf / glsc )**p23 )
-                ENDDO
-                tkefactor_s(k_wall,i) = c_tkef * fw0
-             ENDDO
-          ENDIF
-
-          IF ( bc_dirichlet_n )  THEN
-             ALLOCATE( tkefactor_n(nzb:nzt+1,nxlg:nxrg) )
-             tkefactor_n = 0.0_wp
-             j = nyn + 1
-             DO  i = nxlg, nxrg
-                k_wall = get_topography_top_index_ji( j, i, 's' )
-
-                DO  k = k_wall + 1, nzt
-
-                   kc     = kco(k) + 1
-                   glsf   = ( dx * dy * dzu(k) )**p13
-                   glsc   = ( cg%dx * cg%dy * cg%dzu(kc) )**p13
-                   height = zu(k) - zu(k_wall)
-                   fw     = EXP( -cfw * height / glsf )
-                   tkefactor_n(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *     &
-                                                 ( glsf / glsc )**p23 )
-                ENDDO
-                tkefactor_n(k_wall,i) = c_tkef * fw0
-             ENDDO
-          ENDIF
-
-          ALLOCATE( tkefactor_t(nysg:nyng,nxlg:nxrg) )
-          k = nzt
-
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-!
-!--             Determine vertical index for local topography top
-                k_wall = get_topography_top_index_ji( j, i, 's' )
-
-                kc     = kco(k) + 1
-                glsf   = ( dx * dy * dzu(k) )**p13
-                glsc   = ( cg%dx * cg%dy * cg%dzu(kc) )**p13
-                height = zu(k) - zu(k_wall)
-                fw     = EXP( -cfw * height / glsf )
-                tkefactor_t(j,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *        &
-                                              ( glsf / glsc )**p23 )
-             ENDDO
-          ENDDO
-!
-!--    RANS mode
-       ELSE
-          IF ( bc_dirichlet_l )  THEN
-             ALLOCATE( tkefactor_l(nzb:nzt+1,nysg:nyng) )
-             tkefactor_l = 1.0_wp
-          ENDIF
-          IF ( bc_dirichlet_r )  THEN
-             ALLOCATE( tkefactor_r(nzb:nzt+1,nysg:nyng) )
-             tkefactor_r = 1.0_wp
-          ENDIF
-          IF ( bc_dirichlet_s )  THEN
-             ALLOCATE( tkefactor_s(nzb:nzt+1,nxlg:nxrg) )
-             tkefactor_s = 1.0_wp
-          ENDIF
-          IF ( bc_dirichlet_n )  THEN
-             ALLOCATE( tkefactor_n(nzb:nzt+1,nxlg:nxrg) )
-             tkefactor_n = 1.0_wp
-          ENDIF
-
-          ALLOCATE( tkefactor_t(nysg:nyng,nxlg:nxrg) )
-          tkefactor_t = 1.0_wp
-
-       ENDIF
-      
-    END SUBROUTINE pmci_init_tkefactor
 
 #endif
@@ -3667,5 +3921,5 @@
 #endif
  END SUBROUTINE pmci_setup_coordinates
- 
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -4029,8 +4283,16 @@
     INTEGER(iwp) ::  i          !<
     INTEGER(iwp) ::  icl        !<
+    INTEGER(iwp) ::  icla       !<
+    INTEGER(iwp) ::  iclw       !<
     INTEGER(iwp) ::  icr        !<
+    INTEGER(iwp) ::  icra       !<
+    INTEGER(iwp) ::  icrw       !<
     INTEGER(iwp) ::  j          !<
     INTEGER(iwp) ::  jcn        !<
+    INTEGER(iwp) ::  jcna       !<
+    INTEGER(iwp) ::  jcnw       !<
     INTEGER(iwp) ::  jcs        !<
+    INTEGER(iwp) ::  jcsa       !<
+    INTEGER(iwp) ::  jcsw       !<
     INTEGER(iwp) ::  k          !< 
     INTEGER(iwp) ::  n          !< running index for chemical species
@@ -4043,8 +4305,17 @@
 !
 !--    Child domain boundaries in the parent index space
-       icl = coarse_bound(1)
-       icr = coarse_bound(2)
-       jcs = coarse_bound(3)
-       jcn = coarse_bound(4)
+       icl  = coarse_bound(1)
+       icr  = coarse_bound(2)
+       jcs  = coarse_bound(3)
+       jcn  = coarse_bound(4)
+       icla = coarse_bound_aux(1)
+       icra = coarse_bound_aux(2)
+       jcsa = coarse_bound_aux(3)
+       jcna = coarse_bound_aux(4)
+       iclw = coarse_bound_w(1)
+       icrw = coarse_bound_w(2)
+       jcsw = coarse_bound_w(3)
+       jcnw = coarse_bound_w(4)
+
 !
 !--    Get data from the parent
@@ -4052,11 +4323,11 @@
 !
 !--    The interpolation.
-       CALL pmci_interp_tril_all ( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,   &
+       CALL pmci_interp_1sto_all ( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,   &
                                    r2yo, r1zo, r2zo, kcto, iflu, ifuu,         &
                                    jflo, jfuo, kflo, kfuo, ijkfc_u, 'u' )
-       CALL pmci_interp_tril_all ( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,   &
+       CALL pmci_interp_1sto_all ( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,   &
                                    r2yv, r1zo, r2zo, kcto, iflo, ifuo,         &
                                    jflv, jfuv, kflo, kfuo, ijkfc_v, 'v' )
-       CALL pmci_interp_tril_all ( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,   &
+       CALL pmci_interp_1sto_all ( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,   &
                                    r2yo, r1zw, r2zw, kctw, iflo, ifuo,         &
                                    jflo, jfuo, kflw, kfuw, ijkfc_w, 'w' )
@@ -4065,5 +4336,5 @@
             (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.           &
                .NOT. constant_diffusion ) )  THEN
-          CALL pmci_interp_tril_all ( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo, &
+          CALL pmci_interp_1sto_all ( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo, &
                                       r2yo, r1zo, r2zo, kcto, iflo, ifuo,       &
                                       jflo, jfuo, kflo, kfuo, ijkfc_s, 'e' )
@@ -4071,5 +4342,5 @@
 
        IF ( rans_mode_parent  .AND.  rans_mode  .AND.  rans_tke_e )  THEN
-          CALL pmci_interp_tril_all ( diss,  dissc,  ico, jco, kco, r1xo, r2xo,&
+          CALL pmci_interp_1sto_all ( diss,  dissc,  ico, jco, kco, r1xo, r2xo,&
                                       r1yo, r2yo, r1zo, r2zo, kcto, iflo, ifuo,&
                                       jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
